#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()
#define ll long long
using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, q, l, r;
    cin>>n;
    vector<int> a(n), dif(n), neg(n, 0), moze(n, 0);
    for(int i=0; i<n; i++){
        cin>>a[i];
        if(i) dif[i]=a[i]-a[i-1];
        else dif[i]=0;
        if(dif[i]<0) neg[i]=1;
        if(i) neg[i]+=neg[i-1];
    }
    for(int i=1; i<n-1; i++){
        if(dif[i]<0) if((dif[i]+max(dif[i-1], dif[i+1]))>=0) moze[i]=1;
        moze[i]+=moze[i-1];
    }
    if(n>=2) moze[n-1]=moze[n-2];
    cin>>q;
   /* for(int x : dif) cout<<x<<' ';
    cout<<endl;
    for(int x : neg) cout<<x<<' ';
    cout<<endl;
    for(int x : moze) cout<<x<<' ';
    cout<<endl;*/
    while(q--){
        cin>>l>>r;
        int br=neg[r-1]-neg[l-1];
        if(br>1) cout<<"NE\n";
        else if(br==0) cout<<"DA\n";
        else{
            if(dif[l]<0) cout<<"DA\n";
            else if(dif[r-1]<0) cout<<"DA\n";
            else{
                if((moze[r-1]-moze[l-1])>0) cout<<"DA\n";
                else cout<<"NE\n";
            }
        }
    }
    return 0;
}